# Author: Jan Vcelak <jvcelak@redhat.com>

class Limits
	attr_accessor :time, :memory, :process_count

	def initialize(time = nil, memory = nil, process_count = nil)
		@time = time
		@memory = memory
		@process_count = process_count
	end

	def ulimit_command
		options = []

		options << "-t %d" % @time unless @time.nil?
		options << "-m %d" % @memory unless @memory.nil?
		options << "-u %d" % @process_count unless @process_count.nil?

		if options.empty?
			return nil
		else
			return "ulimit " + options.join(" ")
		end
	end

	def self.from_config(server_config)
		Limits.new \
			server_config["limits.cputime_seconds"],
			server_config["limits.memory_megabytes"],
			server_config["limits.process_count"]
	end
end

