# Author: Jan Vcelak <jvcelak@redhat.com>

require "shellwords"

class Log
	def initialize(filename, append=true)
		@file = File.new filename, (append ? "a" : "w")
	end

	def close
		@file.close
		@file = nil
	end

	def msg(*messages)
		return if @file.nil?
		@file.puts *messages
		@file.flush
	end

	def cmd(args)
		return if @file.nil?
		@file.puts "+ %s" % Shellwords.join(args)
		@file.flush
	end
end
