# Author: Jan Vcelak <jvcelak@redhat.com>

require "bughunting/check/task"
require "bughunting/server/config"
require "bughunting/install/installer"

class InstallController
	def initialize(server_config_name)
		@config = ServerConfig.load_file server_config_name
                @tasks = Task.load_dir @config["paths.tasks"]
	end

	def install(host)
		installer = Installer.new \
			host,
			@config["clients.user"],
			@config["clients.identity_file"],
			@config["clients.sources_dir"],
			@config["clients.cache_dir"]
		  
		errors = []
		
		installer.clean_full
		installer.push_sources @tasks
		installer.run_setup @tasks
		installer.create_cache @tasks
	end
end
