# Author: Jan Vcelak <jvcelak@redhat.com>

require "shellwords"

# TODO: needs rewrite!

class Installer
	def initialize(host, user, identity_file, sources_dir, cache_dir)
		@host = host
		@user = user
		@identity_file = identity_file
		@sources_dir = sources_dir
		@cache_dir = cache_dir
	end

	def clean_full
		remote_execute "rm -rf ~/#{@sources_dir}; mkdir -p ~/#{@sources_dir}"
		remote_execute "rm -rf #{@cache_dir}; mkdir -m 0700 -p #{@cache_dir}", true
	end

	def push_sources(tasks)
		tasks.each do |task_name, task|
			to = "~#{@user}/#{@sources_dir}/#{task_name}"
			if task.symlinked_source
				from = task.source_dir.split("/")[-2]
				remote_execute "ln -sf #{from} #{to}"
			else
				from = task.source_dir
				ssh_copy_to from, to
			end
		end
	end

	def run_setup(tasks)
		tasks.each do |task_name, task|
			next if task.symlinked_source

			setup_commands = task.config["setup_commands"]
			next if setup_commands.nil? or setup_commands.empty?

			commands = []
			commands << "cd ~#{@user}/#{@sources_dir}/#{task_name}"
			commands += setup_commands

			remote_execute commands.join(";")
		end
	end

	def create_cache(tasks)
		copy_sources = []
		tasks.each do |task_name, task|
			copy_sources << "~#{@user}/#{@sources_dir}/#{task_name}"
		end
		remote_execute (["cp", "-ar"] + copy_sources + [ @cache_dir ]).join(" "), true
	end

	def recover(tasks)
		# TODO: complete
	end

	private

	def remote_execute(command, superuser=false)
		system [
			"/usr/bin/ssh",
			"-o", "BatchMode=yes",
			"-o", "StrictHostKeyChecking=no",
			"-i", @identity_file,
			"-l", superuser ? "root" : @user,
			@host,
			"/bin/sh -xc '#{command}'"
		]
	end

	def ssh_copy_to(from, to)
		system [
			"/usr/bin/scp",
			"-pr",
			"-o", "BatchMode=yes",
			"-o", "StrictHostKeyChecking=no",
			"-i", @identity_file,
			from,
			"#{@user}@#{@host}:#{to}"
		]
	end

	def system(commands)
		puts "+ %s" % Shellwords.join(commands)
		Kernel.system *commands
		puts "result: %d" % $?
		$? == 0
	end
end
