# Author: Jan Vcelak <jvcelak@redhat.com>

require "bughunting/common/config"

class ServerConfig < BaseConfig
	def self.get_defaults
		{
			"listen" => {
				"ip" => "0.0.0.0",
				"port" => 2230,
			},
			"limits" => {
				"cputime_seconds" => 5,
				"memory_megabytes" => 32,
				"process_count" => 32,
			},
			"clients" => {
				"user" => "test",
				"identity_file" => "/etc/bughunting/remote_id_rsa",
				"sources_dir" => "sources",
				"cache_dir" => "/var/lib/bughunting/cache",
			},
			"paths" => {
				"tasks" => "/usr/share/bughunting/tasks",
				"archive" => "/var/run/bughunting/archive",
			},	
		}.clone
	end
end
