# Author: Jan Vcelak <jvcelak@redhat.com>

require "bughunting/check/carrier"
require "bughunting/check/task"
require "bughunting/server/config"
require "bughunting/server/server"
require "bughunting/server/service"
require "bughunting/server/users"

class ServerController
	def initialize(config_filename, local)
		@config_filename = config_filename
		@local = local
	end

	def run
		config = ServerConfig.load_file @config_filename

		clients_sources = config["clients.sources_dir"]
		carrier_factory = CarrierFactory.new clients_sources

		if @local
			user = config["users"][0]
			service = DevelServerService.new config, user, carrier_factory
		else
			tasks = Task.load_dir config["paths.tasks"]
			users = Users.new config["users"]
			service = CompetitionServerService.new config, users, tasks, carrier_factory
		end

		server = Server.new config, service, @local
		server.serve
	end
end
